diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index c97ee24..2c0ceb8 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -1134,6 +1134,8 @@ _outAggref(StringInfo str, const Aggref *node)
 	WRITE_OID_FIELD(aggcollid);
 	WRITE_OID_FIELD(inputcollid);
 	WRITE_OID_FIELD(aggtranstype);
+	WRITE_OID_FIELD(aggcombinefn);
+	WRITE_OID_FIELD(aggfinalfn);
 	WRITE_NODE_FIELD(aggargtypes);
 	WRITE_NODE_FIELD(aggdirectargs);
 	WRITE_NODE_FIELD(args);
@@ -2223,6 +2225,7 @@ _outPlannerInfo(StringInfo str, const PlannerInfo *node)
 	WRITE_NODE_FIELD(pcinfo_list);
 	WRITE_NODE_FIELD(rowMarks);
 	WRITE_NODE_FIELD(placeholder_list);
+	WRITE_NODE_FIELD(grouped_var_list);
 	WRITE_NODE_FIELD(fkey_list);
 	WRITE_NODE_FIELD(query_pathkeys);
 	WRITE_NODE_FIELD(group_pathkeys);
@@ -2230,6 +2233,7 @@ _outPlannerInfo(StringInfo str, const PlannerInfo *node)
 	WRITE_NODE_FIELD(distinct_pathkeys);
 	WRITE_NODE_FIELD(sort_pathkeys);
 	WRITE_NODE_FIELD(processed_tlist);
+	WRITE_INT_FIELD(max_sortgroupref);
 	WRITE_NODE_FIELD(minmax_aggs);
 	WRITE_FLOAT_FIELD(total_table_pages, "%.0f");
 	WRITE_FLOAT_FIELD(tuple_fraction, "%.4f");
@@ -2269,6 +2273,7 @@ _outRelOptInfo(StringInfo str, const RelOptInfo *node)
 	WRITE_NODE_FIELD(cheapest_parameterized_paths);
 	WRITE_BITMAPSET_FIELD(direct_lateral_relids);
 	WRITE_BITMAPSET_FIELD(lateral_relids);
+	WRITE_NODE_FIELD(gpi);
 	WRITE_UINT_FIELD(relid);
 	WRITE_OID_FIELD(reltablespace);
 	WRITE_ENUM_FIELD(rtekind, RTEKind);
@@ -2445,6 +2450,18 @@ _outParamPathInfo(StringInfo str, const ParamPathInfo *node)
 }
 
 static void
+_outGroupedPathInfo(StringInfo str, const GroupedPathInfo *node)
+{
+	WRITE_NODE_TYPE("GROUPEDPATHINFO");
+
+	WRITE_NODE_FIELD(target);
+	WRITE_NODE_FIELD(group_exprs);
+	WRITE_NODE_FIELD(pathlist);
+	WRITE_NODE_FIELD(partial_pathlist);
+	WRITE_NODE_FIELD(sortgroupclauses);
+}
+
+static void
 _outRestrictInfo(StringInfo str, const RestrictInfo *node)
 {
 	WRITE_NODE_TYPE("RESTRICTINFO");
@@ -2488,6 +2505,17 @@ _outPlaceHolderVar(StringInfo str, const PlaceHolderVar *node)
 }
 
 static void
+_outGroupedVar(StringInfo str, const GroupedVar *node)
+{
+	WRITE_NODE_TYPE("GROUPEDVAR");
+
+	WRITE_NODE_FIELD(gvexpr);
+	WRITE_NODE_FIELD(agg_partial);
+	WRITE_UINT_FIELD(sortgroupref);
+	WRITE_UINT_FIELD(gvid);
+}
+
+static void
 _outSpecialJoinInfo(StringInfo str, const SpecialJoinInfo *node)
 {
 	WRITE_NODE_TYPE("SPECIALJOININFO");
@@ -2541,6 +2569,19 @@ _outPlaceHolderInfo(StringInfo str, const PlaceHolderInfo *node)
 }
 
 static void
+_outGroupedVarInfo(StringInfo str, const GroupedVarInfo *node)
+{
+	WRITE_NODE_TYPE("GROUPEDVARINFO");
+
+	WRITE_UINT_FIELD(gvid);
+	WRITE_NODE_FIELD(gvexpr);
+	WRITE_NODE_FIELD(agg_partial);
+	WRITE_UINT_FIELD(sortgroupref);
+	WRITE_BITMAPSET_FIELD(gv_eval_at);
+	WRITE_INT_FIELD(gv_width);
+}
+
+static void
 _outMinMaxAggInfo(StringInfo str, const MinMaxAggInfo *node)
 {
 	WRITE_NODE_TYPE("MINMAXAGGINFO");
@@ -4043,12 +4084,18 @@ outNode(StringInfo str, const void *obj)
 			case T_ParamPathInfo:
 				_outParamPathInfo(str, obj);
 				break;
+			case T_GroupedPathInfo:
+				_outGroupedPathInfo(str, obj);
+				break;
 			case T_RestrictInfo:
 				_outRestrictInfo(str, obj);
 				break;
 			case T_PlaceHolderVar:
 				_outPlaceHolderVar(str, obj);
 				break;
+			case T_GroupedVar:
+				_outGroupedVar(str, obj);
+				break;
 			case T_SpecialJoinInfo:
 				_outSpecialJoinInfo(str, obj);
 				break;
@@ -4061,6 +4108,9 @@ outNode(StringInfo str, const void *obj)
 			case T_PlaceHolderInfo:
 				_outPlaceHolderInfo(str, obj);
 				break;
+			case T_GroupedVarInfo:
+				_outGroupedVarInfo(str, obj);
+				break;
 			case T_MinMaxAggInfo:
 				_outMinMaxAggInfo(str, obj);
 				break;
diff --git a/src/backend/nodes/readfuncs.c b/src/backend/nodes/readfuncs.c
index 7eb67fc0..74bfb5e 100644
--- a/src/backend/nodes/readfuncs.c
+++ b/src/backend/nodes/readfuncs.c
@@ -529,6 +529,22 @@ _readVar(void)
 }
 
 /*
+ * _readGroupedVar
+ */
+static GroupedVar *
+_readGroupedVar(void)
+{
+	READ_LOCALS(GroupedVar);
+
+	READ_NODE_FIELD(gvexpr);
+	READ_NODE_FIELD(agg_partial);
+	READ_UINT_FIELD(sortgroupref);
+	READ_UINT_FIELD(gvid);
+
+	READ_DONE();
+}
+
+/*
  * _readConst
  */
 static Const *
@@ -584,6 +600,8 @@ _readAggref(void)
 	READ_OID_FIELD(aggcollid);
 	READ_OID_FIELD(inputcollid);
 	READ_OID_FIELD(aggtranstype);
+	READ_OID_FIELD(aggcombinefn);
+	READ_OID_FIELD(aggfinalfn);
 	READ_NODE_FIELD(aggargtypes);
 	READ_NODE_FIELD(aggdirectargs);
 	READ_NODE_FIELD(args);
@@ -2470,6 +2488,8 @@ parseNodeString(void)
 		return_value = _readTableFunc();
 	else if (MATCH("VAR", 3))
 		return_value = _readVar();
+	else if (MATCH("GROUPEDVAR", 10))
+		return_value = _readGroupedVar();
 	else if (MATCH("CONST", 5))
 		return_value = _readConst();
 	else if (MATCH("PARAM", 5))
diff --git a/src/backend/optimizer/README b/src/backend/optimizer/README
index 1e4084d..3994394 100644
--- a/src/backend/optimizer/README
+++ b/src/backend/optimizer/README
@@ -1076,6 +1076,41 @@ plan as possible.  Expanding the range of cases in which more work can be
 pushed below the Gather (and costing them accurately) is likely to keep us
 busy for a long time to come.
 
+Grouped Paths
+-------------
+
+If both query semantics and path type allow, an existing path can be subject
+to partial aggregation (ie aggregation without calling the aggfinalfn
+function) and stored as a "grouped path" in a separate pathlist. Both base
+relation and join paths can be turned into a grouped path this way. If the
+source path was partial (in terms of parallel processing, see above), then the
+grouped path is called "partial grouped path".
+
+If a grouped path appears at the top of the join tree, the transient state
+values are aggregated and the aggfinalfn function is called for each
+aggregate. Likewise, if the top-level join produces a partial grouped path, we
+first apply Gather plan on it and then we finalize the aggregation in the same
+way.
+
+Besides being a result of aggregation, (partial) grouped path can be created
+by joining an existing grouped path to an ordinary (non-grouped) path. This
+technique can result in duplication of grouping keys, which are essentially
+unique in the output of aggregation. The final aggregation takes these
+duplicities into account.
+
+In contrast, join of two grouped paths is not supported as there doesn't seem
+to be an interesting use case for it. If we want to support this kind of join
+in the future, additional attention needs to be paid to the duplication of
+grouping keys mentioned above. For example, if scan of table A is joined to a
+grouped scan of table B, then the cardinality of grouping keys of table B
+present in (non-grouped) table A determines how many times does each
+aggregation transient state value of B appear on the input of the final
+aggregation path. However if A is grouped too, the number of those key values
+on the A side can get lower and thus affect the input of the final aggregation
+path. When compensating for this effect, we'd have to count input values of
+each group during the aggregation of A and "multiply" the corresponding
+transient state values of B accordingly.
+
 Partition-wise joins
 --------------------
 A join between two similarly partitioned tables can be broken down into joins
diff --git a/src/backend/optimizer/geqo/geqo_eval.c b/src/backend/optimizer/geqo/geqo_eval.c
index 3cf268c..30ac459 100644
--- a/src/backend/optimizer/geqo/geqo_eval.c
+++ b/src/backend/optimizer/geqo/geqo_eval.c
@@ -268,7 +268,8 @@ merge_clump(PlannerInfo *root, List *clumps, Clump *new_clump, bool force)
 				generate_partition_wise_join_paths(root, joinrel);
 
 				/* Create GatherPaths for any useful partial paths for rel */
-				generate_gather_paths(root, joinrel);
+				generate_gather_paths(root, joinrel, false);
+				generate_gather_paths(root, joinrel, true);
 
 				/* Find and save the cheapest paths for this joinrel */
 				set_cheapest(joinrel);
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 44f6b03..9cd5228 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -97,7 +97,8 @@ static void set_append_rel_pathlist(PlannerInfo *root, RelOptInfo *rel,
 static void generate_mergeappend_paths(PlannerInfo *root, RelOptInfo *rel,
 						   List *live_childrels,
 						   List *all_child_pathkeys,
-						   List *partitioned_rels);
+						   List *partitioned_rels,
+						   bool grouped);
 static Path *get_cheapest_parameterized_child_path(PlannerInfo *root,
 									  RelOptInfo *rel,
 									  Relids required_outer);
@@ -345,6 +346,7 @@ set_rel_size(PlannerInfo *root, RelOptInfo *rel,
 		switch (rel->rtekind)
 		{
 			case RTE_RELATION:
+				remove_restrictions_implied_by_constraints(root, rel, rte);
 				if (rte->relkind == RELKIND_FOREIGN_TABLE)
 				{
 					/* Foreign table */
@@ -487,7 +489,10 @@ set_rel_pathlist(PlannerInfo *root, RelOptInfo *rel,
 	 * we'll consider gathering partial paths for the parent appendrel.)
 	 */
 	if (rel->reloptkind == RELOPT_BASEREL)
-		generate_gather_paths(root, rel);
+	{
+		generate_gather_paths(root, rel, false);
+		generate_gather_paths(root, rel, true);
+	}
 
 	/*
 	 * Allow a plugin to editorialize on the set of Paths for this base
@@ -688,6 +693,7 @@ static void
 set_plain_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 {
 	Relids		required_outer;
+	Path	   *seq_path;
 
 	/*
 	 * We don't support pushing join clauses into the quals of a seqscan, but
@@ -696,15 +702,40 @@ set_plain_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 	 */
 	required_outer = rel->lateral_relids;
 
-	/* Consider sequential scan */
-	add_path(rel, create_seqscan_path(root, rel, required_outer, 0));
+	/* Consider sequential scan, both plain and grouped. */
+	seq_path = create_seqscan_path(root, rel, required_outer, 0);
+
+	/* Try to compute unique keys. */
+	make_uniquekeys(root, seq_path);
+
+	add_path(rel, seq_path, false);
+
+	if (rel->gpi != NULL && rel->gpi->target != NULL &&
+		required_outer == NULL)
+	{
+		/*
+		 * Only AGG_HASHED is suitable here as it does not expect the input +
+		 * set to be sorted.
+		 */
+		create_grouped_path(root, rel, seq_path, false, false, AGG_HASHED);
+	}
 
-	/* If appropriate, consider parallel sequential scan */
+	/* If appropriate, consider parallel sequential scan (plain or grouped) */
 	if (rel->consider_parallel && required_outer == NULL)
 		create_plain_partial_paths(root, rel);
 
 	/* Consider index scans */
-	create_index_paths(root, rel);
+	create_index_paths(root, rel, false);
+	if (rel->gpi != NULL)
+	{
+		/*
+		 * TODO Instead of calling the whole clause-matching machinery twice
+		 * (there should be no difference between plain and grouped paths from
+		 * this point of view), consider returning a separate list of paths
+		 * usable as grouped ones.
+		 */
+		create_index_paths(root, rel, true);
+	}
 
 	/* Consider TID scans */
 	create_tidscan_paths(root, rel);
@@ -718,6 +749,7 @@ static void
 create_plain_partial_paths(PlannerInfo *root, RelOptInfo *rel)
 {
 	int			parallel_workers;
+	Path	   *path;
 
 	parallel_workers = compute_parallel_worker(rel, rel->pages, -1);
 
@@ -726,7 +758,130 @@ create_plain_partial_paths(PlannerInfo *root, RelOptInfo *rel)
 		return;
 
 	/* Add an unordered partial path based on a parallel sequential scan. */
-	add_partial_path(rel, create_seqscan_path(root, rel, NULL, parallel_workers));
+	path = create_seqscan_path(root, rel, NULL, parallel_workers);
+	add_partial_path(rel, path, false);
+
+	/*
+	 * Do partial aggregation at base relation level if the relation is
+	 * eligible for it. Only AGG_HASHED is suitable here as it does not expect
+	 * the input set to be sorted.
+	 */
+	if (rel->gpi != NULL)
+		create_grouped_path(root, rel, path, false, true, AGG_HASHED);
+}
+
+/*
+ * Apply partial aggregation to a subpath and add the AggPath to the
+ * appropriate pathlist.
+ *
+ * "precheck" tells whether the aggregation path should first be checked using
+ * add_path_precheck().
+ *
+ * If "partial" is true, the resulting path is considered partial in terms of
+ * parallel execution.
+ *
+ * The path we create here shouldn't be parameterized because of supposedly
+ * high startup cost of aggregation (whether due to build of hash table for
+ * AGG_HASHED strategy or due to explicit sort for AGG_SORTED).
+ *
+ * XXX IndexPath as an input for AGG_SORTED seems to be an exception ---
+ * consider implementing parameterized AGG_SORTED unless the IndexPath is
+ * partial.
+ */
+void
+create_grouped_path(PlannerInfo *root, RelOptInfo *rel, Path *subpath,
+					bool precheck, bool partial, AggStrategy aggstrategy)
+{
+	List	   *group_clauses = NIL;
+	List	   *group_exprs = NIL;
+	List	   *agg_exprs = NIL;
+	Path	   *agg_path;
+
+	/*
+	 * If the AggPath should be partial, the subpath must be too, and
+	 * therefore the subpath is essentially parallel_safe.
+	 */
+	Assert(subpath->parallel_safe || !partial);
+
+	/*
+	 * Grouped path should never be parameterized, so we're not supposed to
+	 * receive parameterized subpath.
+	 */
+	Assert(subpath->param_info == NULL || aggstrategy != AGG_HASHED);
+
+	/*
+	 * Non-var grouping expressions will eventually require projection using
+	 * Result plan, but that does not work with SRFs.
+	 */
+	Assert(rel->gpi != NULL);
+	if (rel->gpi->group_exprs != NULL)
+	{
+		ListCell   *lc;
+
+		foreach(lc, rel->gpi->group_exprs->exprs)
+		{
+			GroupedVar *gvar = lfirst_node(GroupedVar, lc);
+
+			if (IsA(gvar->gvexpr, FuncExpr))
+			{
+				FuncExpr   *fexpr = (FuncExpr *) gvar->gvexpr;
+
+				if (fexpr->funcretset)
+					return;
+			}
+		}
+	}
+
+	/*
+	 * Note that "partial" in the following function names refers to 2-stage
+	 * aggregation, not to parallel processing.
+	 */
+	if (aggstrategy == AGG_HASHED)
+		agg_path = (Path *) create_partial_agg_hashed_path(root, subpath,
+														   true,
+														   &group_clauses,
+														   &group_exprs,
+														   &agg_exprs,
+														   subpath->rows,
+														   partial);
+	else if (aggstrategy == AGG_SORTED)
+		agg_path = (Path *) create_partial_agg_sorted_path(root, subpath,
+														   true,
+														   &group_clauses,
+														   &group_exprs,
+														   &agg_exprs,
+														   subpath->rows,
+														   partial);
+	else
+		elog(ERROR, "unexpected strategy %d", aggstrategy);
+
+	/* Add the grouped path to the list of grouped base paths. */
+	if (agg_path != NULL)
+	{
+		if (precheck)
+		{
+			List	   *pathkeys;
+
+			/* AGG_HASH is not supposed to generate sorted output. */
+			pathkeys = aggstrategy == AGG_SORTED ? subpath->pathkeys : NIL;
+
+			if (!partial &&
+				!add_path_precheck(rel, agg_path->startup_cost,
+								   agg_path->total_cost, pathkeys, NULL,
+								   true))
+				return;
+
+			if (partial &&
+				!add_partial_path_precheck(rel, agg_path->total_cost, pathkeys,
+										   true))
+				return;
+		}
+
+		if (!partial)
+			add_path(rel, (Path *) agg_path, true);
+		else
+			add_partial_path(rel, (Path *) agg_path, true);
+	}
 }
 
 /*
@@ -812,7 +967,7 @@ set_tablesample_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *
 		path = (Path *) create_material_path(rel, path);
 	}
 
-	add_path(rel, path);
+	add_path(rel, path, false);
 
 	/* For the moment, at least, there are no other paths to consider */
 }
@@ -824,11 +979,29 @@ set_tablesample_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *
 static void
 set_foreign_size(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 {
+	Relids		required_outer = rel->lateral_relids;
+
 	/* Mark rel with estimated output rows, width, etc */
-	set_foreign_size_estimates(root, rel);
+	set_foreign_size_estimates(root, rel, false);
+
+	/*
+	 * Let FDW adjust the size estimates, if it can.
+	 *
+	 * For the grouped relation it only makes sense if set_foreign_pathlist is
+	 * supposed to handle it, see below.
+	 */
+	rel->fdwroutine->GetForeignRelSize(root, rel, rte->relid, false);
+	if (rel->gpi != NULL && rel->gpi->target != NULL &&
+		required_outer == NULL)
+	{
+		rel->fdwroutine->GetForeignRelSize(root, rel, rte->relid, true);
 
-	/* Let FDW adjust the size estimates, if it can */
-	rel->fdwroutine->GetForeignRelSize(root, rel, rte->relid);
+		/*
+		 * XXX Should cost_qual_eval be called separate so we don't repeat it
+		 * here for essentially identical baserestrictinfo?
+		 */
+		set_foreign_size_estimates(root, rel, true);
+	}
 
 	/* ... but do not let it set the rows estimate to zero */
 	rel->rows = clamp_row_est(rel->rows);
@@ -841,8 +1014,18 @@ set_foreign_size(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 static void
 set_foreign_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 {
+	Relids		required_outer = rel->lateral_relids;
+
 	/* Call the FDW's GetForeignPaths function to generate path(s) */
-	rel->fdwroutine->GetForeignPaths(root, rel, rte->relid);
+	rel->fdwroutine->GetForeignPaths(root, rel, rte->relid, false);
+
+	/*
+	 * Create grouped paths if grouped target exists. Do nothing if outer
+	 * relations are needed --- that could cause parameterized (and therefore
+	 * repeated) grouping.
+	 */
+	if (rel->gpi != NULL && rel->gpi->target && required_outer == NULL)
+		rel->fdwroutine->GetForeignPaths(root, rel, rte->relid, true);
 }
 
 /*
@@ -1130,12 +1313,44 @@ set_append_rel_size(PlannerInfo *root, RelOptInfo *rel,
 			set_dummy_rel_pathlist(childrel);
 			continue;
 		}
+		remove_restrictions_implied_by_constraints(root, childrel, childRTE);
 
 		/* CE failed, so finish copying/modifying join quals. */
 		childrel->joininfo = (List *)
 			adjust_appendrel_attrs(root,
 								   (Node *) rel->joininfo,
 								   1, &appinfo);
+		childrel->reltarget->exprs = (List *)
+			adjust_appendrel_attrs(root,
+								   (Node *) rel->reltarget->exprs,
+								   1, &appinfo);
+
+		/*
+		 * Setup GroupedPathInfo for the child relation if the parent has
+		 * some.
+		 */
+		if (rel->gpi != NULL)
+			build_chiid_rel_gpi(root, childrel, rel, 1, &appinfo);
+
+		/*
+		 * We have to make child entries in the EquivalenceClass data
+		 * structures as well.  This is needed either if the parent
+		 * participates in some eclass joins (because we will want to consider
+		 * inner-indexscan joins on the individual children) or if the parent
+		 * has useful pathkeys (because we should try to build MergeAppend
+		 * paths that produce those sort orderings).
+		 */
+		if (rel->has_eclass_joins || has_useful_pathkeys(root, rel))
+			add_child_rel_equivalences(root, appinfo, rel, childrel);
+		childrel->has_eclass_joins = rel->has_eclass_joins;
+
+		/*
+		 * Note: we could compute appropriate attr_needed data for the child's
+		 * variables, by transforming the parent's attr_needed through the
+		 * translated_vars mapping.  However, currently there's no need
+		 * because attr_needed is only examined for base relations not
+		 * otherrels.  So we just leave the child's attr_needed empty.
+		 */
 
 		/*
 		 * If parallelism is allowable for this query in general, see whether
@@ -1332,6 +1547,8 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 	bool		subpaths_valid = true;
 	List	   *partial_subpaths = NIL;
 	bool		partial_subpaths_valid = true;
+	List	   *grouped_subpaths = NIL;
+	bool		grouped_subpaths_valid = true;
 	List	   *all_child_pathkeys = NIL;
 	List	   *all_child_outers = NIL;
 	ListCell   *l;
@@ -1387,6 +1604,7 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 	foreach(l, live_childrels)
 	{
 		RelOptInfo *childrel = lfirst(l);
+		List	   *childpaths;
 		ListCell   *lcp;
 
 		/*
@@ -1421,12 +1639,45 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 			partial_subpaths_valid = false;
 
 		/*
+		 * For grouped paths, use only the unparameterized subpaths.
+		 *
+		 * XXX Consider if the parameterized subpaths should be processed
+		 * below. It's probably not useful for sequential scans (due to
+		 * repeated aggregation), but might be worthwhile for other child
+		 * nodes.
+		 */
+		if (childrel->gpi != NULL && childrel->gpi->pathlist != NIL)
+		{
+			Path	   *path;
+
+			path = (Path *) linitial(childrel->gpi->pathlist);
+			if (path->param_info == NULL)
+				grouped_subpaths = accumulate_append_subpath(grouped_subpaths,
+															 path);
+			else
+				grouped_subpaths_valid = false;
+		}
+		else
+			grouped_subpaths_valid = false;
+
+
+		/*
 		 * Collect lists of all the available path orderings and
 		 * parameterizations for all the children.  We use these as a
 		 * heuristic to indicate which sort orderings and parameterizations we
 		 * should build Append and MergeAppend paths for.
 		 */
-		foreach(lcp, childrel->pathlist)
+		childpaths = childrel->pathlist;
+
+		/*
+		 * Extra orderings may be available for grouped paths, i.e. ordered by
+		 * aggregate. (At least ForeignPath can generate these.)
+		 */
+		if (childrel->gpi != NULL && childrel->gpi->pathlist != NIL)
+			childpaths = list_concat(list_copy(childpaths),
+									 childrel->gpi->pathlist);
+
+		foreach(lcp, childpaths)
 		{
 			Path	   *childpath = (Path *) lfirst(lcp);
 			List	   *childkeys = childpath->pathkeys;
@@ -1492,7 +1743,8 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 	 */
 	if (subpaths_valid)
 		add_path(rel, (Path *) create_append_path(rel, subpaths, NULL, 0,
-												  partitioned_rels));
+												  partitioned_rels),
+				 false);
 
 	/*
 	 * Consider an append of partial unordered, unparameterized partial paths.
@@ -1519,8 +1771,25 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 
 		/* Generate a partial append path. */
 		appendpath = create_append_path(rel, partial_subpaths, NULL,
-										parallel_workers, partitioned_rels);
-		add_partial_path(rel, (Path *) appendpath);
+										parallel_workers,
+										partitioned_rels);
+		add_partial_path(rel, (Path *) appendpath, false);
+	}
+
+	/* TODO Also partial grouped paths? */
+	if (grouped_subpaths_valid)
+	{
+		Path	   *path;
+
+		path = (Path *) create_append_path(rel, grouped_subpaths, NULL, 0,
+										   partitioned_rels);
+		/* pathtarget will produce the grouped relation.. */
+		path->pathtarget = rel->gpi->target;
+
+		/* Try to compute unique keys. */
+		make_uniquekeys(root, path);
+
+		add_path(rel, path, true);
 	}
 
 	/*
@@ -1530,7 +1799,11 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 	if (subpaths_valid)
 		generate_mergeappend_paths(root, rel, live_childrels,
 								   all_child_pathkeys,
-								   partitioned_rels);
+								   partitioned_rels, false);
+	if (grouped_subpaths_valid)
+		generate_mergeappend_paths(root, rel, live_childrels,
+								   all_child_pathkeys,
+								   partitioned_rels, true);
 
 	/*
 	 * Build Append paths for each parameterization seen among the child rels.
@@ -1573,7 +1846,8 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 		if (subpaths_valid)
 			add_path(rel, (Path *)
 					 create_append_path(rel, subpaths, required_outer, 0,
-										partitioned_rels));
+										partitioned_rels),
+					 false);
 	}
 }
 
@@ -1604,9 +1878,11 @@ static void
 generate_mergeappend_paths(PlannerInfo *root, RelOptInfo *rel,
 						   List *live_childrels,
 						   List *all_child_pathkeys,
-						   List *partitioned_rels)
+						   List *partitioned_rels,
+						   bool grouped)
 {
 	ListCell   *lcp;
+	PathTarget *target = NULL;
 
 	foreach(lcp, all_child_pathkeys)
 	{
@@ -1615,23 +1891,32 @@ generate_mergeappend_paths(PlannerInfo *root, RelOptInfo *rel,
 		List	   *total_subpaths = NIL;
 		bool		startup_neq_total = false;
 		ListCell   *lcr;
+		Path	   *path;
 
 		/* Select the child paths for this ordering... */
 		foreach(lcr, live_childrels)
 		{
 			RelOptInfo *childrel = (RelOptInfo *) lfirst(lcr);
+			List	   *pathlist;
 			Path	   *cheapest_startup,
 					   *cheapest_total;
 
+			if (grouped &&
+				(childrel->gpi == NULL || childrel->gpi->pathlist == NIL))
+				return;
+
+			pathlist = !grouped ? childrel->pathlist :
+				childrel->gpi->pathlist;
+
 			/* Locate the right paths, if they are available. */
 			cheapest_startup =
-				get_cheapest_path_for_pathkeys(childrel->pathlist,
+				get_cheapest_path_for_pathkeys(pathlist,
 											   pathkeys,
 											   NULL,
 											   STARTUP_COST,
 											   false);
 			cheapest_total =
-				get_cheapest_path_for_pathkeys(childrel->pathlist,
+				get_cheapest_path_for_pathkeys(pathlist,
 											   pathkeys,
 											   NULL,
 											   TOTAL_COST,
@@ -1663,20 +1948,51 @@ generate_mergeappend_paths(PlannerInfo *root, RelOptInfo *rel,
 				accumulate_append_subpath(total_subpaths, cheapest_total);
 		}
 
+		/*
+		 * Special target is needed if the path output should be grouped.
+		 */
+		if (grouped)
+		{
+			Assert(rel->gpi != NULL);
+			target = rel->gpi->target;
+		}
+
 		/* ... and build the MergeAppend paths */
-		add_path(rel, (Path *) create_merge_append_path(root,
-														rel,
-														startup_subpaths,
-														pathkeys,
-														NULL,
-														partitioned_rels));
+		path = (Path *) create_merge_append_path(root,
+												 rel,
+												 target,
+												 startup_subpaths,
+												 pathkeys,
+												 NULL,
+												 partitioned_rels);
+
+		/* Try to compute unique keys. */
+		make_uniquekeys(root, path);
+
+		/* pathtarget will produce the grouped relation.. */
+		if (grouped)
+		{
+			Assert(rel->gpi != NULL && rel->gpi->target != NULL);
+			path->pathtarget = rel->gpi->target;
+		}
+
+		add_path(rel, path, grouped);
+
 		if (startup_neq_total)
-			add_path(rel, (Path *) create_merge_append_path(root,
-															rel,
-															total_subpaths,
-															pathkeys,
-															NULL,
-															partitioned_rels));
+		{
+			path = (Path *) create_merge_append_path(root,
+													 rel,
+													 target,
+													 total_subpaths,
+													 pathkeys,
+													 NULL,
+													 partitioned_rels);
+			make_uniquekeys(root, path);
+			if (grouped)
+				path->pathtarget = rel->gpi->target;
+			add_path(rel, path, grouped);
+		}
+
 	}
 }
 
@@ -1809,7 +2125,7 @@ set_dummy_rel_pathlist(RelOptInfo *rel)
 	rel->pathlist = NIL;
 	rel->partial_pathlist = NIL;
 
-	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0, NIL));
+	add_path(rel, (Path *) create_append_path(rel, NIL, NULL, 0, NIL), false);
 
 	/*
 	 * We set the cheapest path immediately, to ensure that IS_DUMMY_REL()
@@ -2023,7 +2339,7 @@ set_subquery_pathlist(PlannerInfo *root, RelOptInfo *rel,
 		/* Generate outer path using this subpath */
 		add_path(rel, (Path *)
 				 create_subqueryscan_path(root, rel, subpath,
-										  pathkeys, required_outer));
+										  pathkeys, required_outer), false);
 	}
 }
 
@@ -2092,7 +2408,7 @@ set_function_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 
 	/* Generate appropriate path */
 	add_path(rel, create_functionscan_path(root, rel,
-										   pathkeys, required_outer));
+										   pathkeys, required_outer), false);
 }
 
 /*
@@ -2112,7 +2428,7 @@ set_values_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 	required_outer = rel->lateral_relids;
 
 	/* Generate appropriate path */
-	add_path(rel, create_valuesscan_path(root, rel, required_outer));
+	add_path(rel, create_valuesscan_path(root, rel, required_outer), false);
 }
 
 /*
@@ -2133,7 +2449,7 @@ set_tablefunc_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 
 	/* Generate appropriate path */
 	add_path(rel, create_tablefuncscan_path(root, rel,
-											required_outer));
+											required_outer), false);
 }
 
 /*
@@ -2199,7 +2515,7 @@ set_cte_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 	required_outer = rel->lateral_relids;
 
 	/* Generate appropriate path */
-	add_path(rel, create_ctescan_path(root, rel, required_outer));
+	add_path(rel, create_ctescan_path(root, rel, required_outer), false);
 }
 
 /*
@@ -2226,7 +2542,8 @@ set_namedtuplestore_pathlist(PlannerInfo *root, RelOptInfo *rel,
 	required_outer = rel->lateral_relids;
 
 	/* Generate appropriate path */
-	add_path(rel, create_namedtuplestorescan_path(root, rel, required_outer));
+	add_path(rel, create_namedtuplestorescan_path(root, rel, required_outer),
+			 false);
 
 	/* Select cheapest path (pretty easy in this case...) */
 	set_cheapest(rel);
@@ -2279,7 +2596,8 @@ set_worktable_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 	required_outer = rel->lateral_relids;
 
 	/* Generate appropriate path */
-	add_path(rel, create_worktablescan_path(root, rel, required_outer));
+	add_path(rel, create_worktablescan_path(root, rel, required_outer),
+			 false);
 }
 
 /*
@@ -2292,14 +2610,21 @@ set_worktable_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
  * path that some GatherPath or GatherMergePath has a reference to.)
  */
 void
-generate_gather_paths(PlannerInfo *root, RelOptInfo *rel)
+generate_gather_paths(PlannerInfo *root, RelOptInfo *rel, bool grouped)
 {
 	Path	   *cheapest_partial_path;
 	Path	   *simple_gather_path;
+	List	   *pathlist = NIL;
+	PathTarget *partial_target;
 	ListCell   *lc;
 
+	if (!grouped)
+		pathlist = rel->partial_pathlist;
+	else if (rel->gpi != NULL)
+		pathlist = rel->gpi->partial_pathlist;
+
 	/* If there are no partial paths, there's nothing to do here. */
-	if (rel->partial_pathlist == NIL)
+	if (pathlist == NIL)
 		return;
 
 	/*
@@ -2307,17 +2632,23 @@ generate_gather_paths(PlannerInfo *root, RelOptInfo *rel)
 	 * path of interest: the cheapest one.  That will be the one at the front
 	 * of partial_pathlist because of the way add_partial_path works.
 	 */
-	cheapest_partial_path = linitial(rel->partial_pathlist);
+	cheapest_partial_path = linitial(pathlist);
+
+	if (!grouped)
+		partial_target = rel->reltarget;
+	else if (rel->gpi != NULL && rel->gpi->target != NULL)
+		partial_target = rel->gpi->target;
+
 	simple_gather_path = (Path *)
-		create_gather_path(root, rel, cheapest_partial_path, rel->reltarget,
+		create_gather_path(root, rel, cheapest_partial_path, partial_target,
 						   NULL, NULL);
-	add_path(rel, simple_gather_path);
+	add_path(rel, simple_gather_path, grouped);
 
 	/*
 	 * For each useful ordering, we can consider an order-preserving Gather
 	 * Merge.
 	 */
-	foreach(lc, rel->partial_pathlist)
+	foreach(lc, pathlist)
 	{
 		Path	   *subpath = (Path *) lfirst(lc);
 		GatherMergePath *path;
@@ -2325,9 +2656,9 @@ generate_gather_paths(PlannerInfo *root, RelOptInfo *rel)
 		if (subpath->pathkeys == NIL)
 			continue;
 
-		path = create_gather_merge_path(root, rel, subpath, rel->reltarget,
+		path = create_gather_merge_path(root, rel, subpath, partial_target,
 										subpath->pathkeys, NULL, NULL);
-		add_path(rel, &path->path);
+		add_path(rel, &path->path, grouped);
 	}
 }
 
@@ -2499,7 +2830,8 @@ standard_join_search(PlannerInfo *root, int levels_needed, List *initial_rels)
 			generate_partition_wise_join_paths(root, rel);
 
 			/* Create GatherPaths for any useful partial paths for rel */
-			generate_gather_paths(root, rel);
+			generate_gather_paths(root, rel, false);
+			generate_gather_paths(root, rel, true);
 
 			/* Find and save the cheapest paths for this rel */
 			set_cheapest(rel);
@@ -3152,7 +3484,8 @@ create_partial_bitmap_paths(PlannerInfo *root, RelOptInfo *rel,
 		return;
 
 	add_partial_path(rel, (Path *) create_bitmap_heap_path(root, rel,
-														   bitmapqual, rel->lateral_relids, 1.0, parallel_workers));
+														   bitmapqual, rel->lateral_relids, 1.0, parallel_workers),
+					 false);
 }
 
 /*
